- NAME
- SYNOPSIS
- DESCRIPTION
- NOTES
- RETURN VALUES
- SEE ALSO
- COPYRIGHT

# NAME

SSL_SESSION_new, SSL_SESSION_up_ref, SSL_SESSION_free - create, free and manage SSL_SESSION structures

# SYNOPSIS

     #include <openssl/ssl.h>

     SSL_SESSION *SSL_SESSION_new(void);
     int SSL_SESSION_up_ref(SSL_SESSION *ses);
     void SSL_SESSION_free(SSL_SESSION *session);

# DESCRIPTION

SSL_SESSION_new() creates a new SSL_SESSION structure and returns a pointer to it.

SSL_SESSION_up_ref() increments the reference count on the given SSL_SESSION structure.

SSL_SESSION_free() decrements the reference count of session and removes the SSL_SESSION structure pointed to by session and frees up the allocated memory, if the reference count has reached 0. If session is NULL nothing is done.

# NOTES

SSL_SESSION objects are allocated, when a TLS/SSL handshake operation is successfully completed. Depending on the settings, see SSL_CTX_flush_sessions(3) operation.

SSL_SESSION_free() must only be called for SSL_SESSION objects, for which the reference count was explicitly incremented (e.g. by calling SSL_get1_session(), see d2i_SSL_SESSION(3). It must not be called on other SSL_SESSION objects, as this would cause incorrect reference counts and therefore program failures.

# RETURN VALUES

SSL_SESSION_new returns a pointer to the newly allocated SSL_SESSION structure or NULL on error.

SSL_SESSION_up_ref returns 1 on success or 0 on error.

# SEE ALSO

SSL_get_session(3), SSL_CTX_flush_sessions(3), COPYRIGHT

Copyright 2000-2016 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.